'Here are some useful articles when creating new PC applications for COM ports:
'(links valid as of June 3, 2008)
'
'"SerialPort Class"
'http://msdn.microsoft.com/en-us/library/system.io.ports.serialport.aspx
'
'"SerialPort Members"
'http://msdn.microsoft.com/en-us/library/system.io.ports.serialport_members.aspx
'
'"SerialPort.DataReceived Event"
'http://msdn.microsoft.com/en-us/library/system.io.ports.serialport.datareceived.aspx
'
'"How to: Make Thread-Safe Calls to Windows Forms Controls"
'http://msdn.microsoft.com/en-us/library/ms171728(VS.80).aspx
'
'"Visual Basic Developer Center"
'http://msdn.microsoft.com/en-us/vbasic/default.aspx?pull=/library/en-us/vbcon/html/vboriintroductiontovisualbasic70forvisualbasicveterans.asp

Imports System.IO.Ports

Public Class Form1
    Delegate Sub SetTextCallback(ByVal [text] As String)

    Dim gX0 As Int16 = 0 'XݍW
    Dim gY0 As Int16 = 0 'YݍW
    Dim gZ0 As Int16 = 0 'ZݍW
    Dim gText As String 'Mf[^
    Dim gM As Integer = 0 '[h
    Dim gS As Integer = 0 'V[PXNo
    Dim VthAD As Integer = 1400 '^臒l
    Dim gZ2 As Int16 'ZT[`


    Dim image1 As Bitmap '͉摜f[^
    Dim mZ(50, 50) As Int16 'Hʌvl
    Dim gMap(50, 50) As Int16 'Mapf[^
    Dim gW, gH As Integer '摜A
    Dim gPw, gPh As Integer 'Asb`

    Dim gi, gj As Integer 'AJE^

    Dim fBX As Integer = 1 'obNbVtO

    Dim gCT As Integer '^CJE^
    Dim gCTN As Integer = 400 'A]
    Dim gCK As Integer '񐔃JE^
    Dim gCKN As Integer = 2 'H



    Dim gZSP As Integer = 20 'T[`sb`
    Dim gi0Z As Integer = -400 'gi=0Zޔ
    Dim gi1Z As Integer = -200 'gi>0Zޔ

    Dim gKZ0 As Integer = -20 'HJnZʒu
    Dim gKZP As Integer = 30 'HZ


    Private Sub UpdateCOMPortList()
        Dim s As String
        Dim i As Integer
        Dim foundDifference As Boolean

        i = 0
        foundDifference = False

        If lstCOMPorts.Items.Count = SerialPort.GetPortNames().Length Then
            For Each s In SerialPort.GetPortNames()
                If lstCOMPorts.Items(i).Equals(s) = False Then
                    foundDifference = True
                End If
                i = i + 1
            Next s
        Else
            foundDifference = True
        End If

        If foundDifference = False Then
            Exit Sub
        End If

        lstCOMPorts.Items.Clear()

        For Each s In SerialPort.GetPortNames()
            lstCOMPorts.Items.Add(s)
        Next s
        lstCOMPorts.SelectedIndex = 0
    End Sub


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        UpdateCOMPortList()
        Select Case gM
            Case 1
                F1()
            Case 2
                F2()
            Case 3
                F3()
            Case Else

        End Select
    End Sub


    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Try
            SerialPort1.PortName = lstCOMPorts.Items(lstCOMPorts.SelectedIndex).ToString()

            SerialPort1.Open()

            btnConnect.Enabled = False
            lstCOMPorts.Enabled = False
            btnClose.Enabled = True

            txtDataReceived.Clear()
            txtDataReceived.AppendText("Connected." + vbCrLf)
        Catch ex As Exception
            btnClose_Click(Me, e)

        End Try
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        btnClose.Enabled = False
        btnConnect.Enabled = True
        lstCOMPorts.Enabled = True

        Try

            SerialPort1.DiscardInBuffer()
            SerialPort1.DiscardOutBuffer()
            SerialPort1.Close()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

        Try
            SetText(SerialPort1.ReadExisting())
        Catch ex As Exception
            btnClose_Click(Me, e)
        End Try

    End Sub

    Private Sub SetText(ByVal [text] As String)
        If txtDataReceived.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf SetText)

            Invoke(d, New Object() {[text]})
        Else
            'text = "CDC Demo=" + text
            If gM < 2 Then
                txtDataReceived.AppendText(text)
            End If

        End If
        gText = text
    End Sub

    Private Sub btnSendData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendData.Click
        Try
            SerialPort1.Write(txtData.Text)
        Catch ex As Exception
            btnClose_Click(Me, e)
        End Try
    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click 'ZT[`
        gM = 1
        gS = 0
        'SerialPort1.Write("AD#")
        txtDataReceived.Text = ""
        'SerialPort1.Write("MR#0#0#-10#")
        gZSP = Val(TextBox5.Text)

    End Sub

    Sub F1()    'ZT[`
        Dim str As String
        Dim AD As Integer

        Select Case gS
            Case 0
                SerialPort1.Write("MA#0#0#0#")
                gS = 1
                gText = ""

            Case 1
                str = Mid(gText, 1, 2)
                If (str = "MC") Then
                    gS = 2
                End If
            Case 2
                SerialPort1.Write("AD#")
                gS = 3
                gText = ""
            Case 3
                str = Mid(gText, 1, 2)
                If (str = "AD") Then
                    txtDataReceived.AppendText("Z0" + vbTab + gZ0.ToString + vbCrLf)
                    str = Mid(gText, 4, gText.Length - 5)
                    AD = Val(str)

                    If (AD > VthAD) Then
                        SerialPort1.Write("MR#0#0#" + gZSP.ToString + "#")
                        gText = ""
                        gZ0 = gZ0 + gZSP
                        gS = 4
                    Else
                        gS = 5
                    End If
                End If
            Case 4
                str = Mid(gText, 1, 2)
                If (str = "MC") Then
                    gS = 2
                End If

            Case 5
                If (gS = 5) Then
                    gZ2 = gZ0 'ZT[`
                    txtDataReceived.AppendText("END" + vbCrLf)
                    gS = 6
                End If

            Case Else

        End Select

    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click 'ʌv

        If (gM = 1 And gS = 6) Then

            gW = Val(TextBox1.Text)
            gH = Val(TextBox2.Text)
            gPw = Val(TextBox3.Text)
            gPh = Val(TextBox4.Text)
            ReDim mZ(gW, gH)

            gi = 0
            gj = 0

            gM = 2
            gS = 0
            txtDataReceived.Text = ""
            txtDataReceived.AppendText("i" + vbTab + "j" + vbTab + "gZ0" + vbCrLf)

            gZSP = Val(TextBox5.Text)
            gi0Z = Val(TextBox6.Text)
            gi1Z = Val(TextBox7.Text)
        Else
            MessageBox.Show("ZT[`sĂII")
        End If
    End Sub

    Sub F2()    'Hʌv
        Dim str As String
        Dim x, y, z, AD As Integer

        Select Case gS
            Case 0
                x = (gi - gW / 2) * gPw
                y = (gj - gH / 2) * gPh
                If (gi = 0) Then
                    z = gZ2 + gi0Z
                Else
                    z = gZ2 + gi1Z
                End If

                SerialPort1.Write("MA#" + x.ToString + "#" + y.ToString + "#" + z.ToString + "#")
                gS = 1
                gText = ""
                gX0 = x : gY0 = y : gZ0 = z
            Case 1
                str = Mid(gText, 1, 2)
                If (str = "MC") Then
                    gS = 2
                End If
            Case 2
                SerialPort1.Write("AD#")
                gS = 3
                gText = ""
            Case 3
                str = Mid(gText, 1, 2)
                If (str = "AD") Then
                    'txtDataReceived.AppendText("Z0" + vbTab + gZ0.ToString + vbCrLf)
                    str = Mid(gText, 4, gText.Length - 5)
                    AD = Val(str)

                    If (AD > VthAD) Then
                        SerialPort1.Write("MR#0#0#" + gZSP.ToString + "#")
                        gText = ""
                        gZ0 = gZ0 + gZSP
                        gS = 4
                    Else
                        gS = 5
                    End If
                End If

            Case 4
                str = Mid(gText, 1, 2)
                If (str = "MC") Then
                    gS = 2
                End If

            Case 5
                If (gS = 5) Then
                    mZ(gi, gj) = gZ0 'ZT[`
                    txtDataReceived.AppendText(gi.ToString + vbTab + gj.ToString + vbTab + gZ0.ToString + vbCrLf)
                    If (gi < gW - 1) Then
                        gi = gi + 1
                        gS = 0
                        'txtDataReceived.Text = ""
                    Else
                        If (gj < gH - 1) Then
                            gi = 0
                            gj = gj + 1
                            gS = 0
                            'txtDataReceived.Text = ""
                        Else
                            gS = 6
                        End If
                    End If
                End If
            Case 6

            Case Else

        End Select

    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click 't@Cۑ
        Dim i, j As Integer

        Dim OutText As String = ""          'ϐOutTextString^Ő
        For j = 0 To gH - 1                     'JԂ
            For i = 0 To gW - 1                   'JԂ
                OutText = OutText & mZ(i, j).ToString + vbTab    'OutText2zvfZ
            Next i
            OutText = OutText & vbCrLf                      'OutTextɉsZ
        Next j
        'SaveFileDialogJ
        If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
            'OutText̓et@Cɏo
            My.Computer.FileSystem.WriteAllText(SaveFileDialog1.FileName, OutText, append:=False)
        End If


    End Sub

    Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click 'Hs
        If (gM = 1 And gS = 6) Then
            If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
                txtDataReceived.Text = ""
                image1 = New Bitmap(OpenFileDialog1.FileName)

                PictureBox1.Load(OpenFileDialog1.FileName)

                Dim x, y As Integer

                TextBox1.Text = image1.Width.ToString
                TextBox2.Text = image1.Height.ToString
                gW = Val(TextBox1.Text)
                gH = Val(TextBox2.Text)
                gPw = Val(TextBox3.Text)
                gPh = Val(TextBox4.Text)

                gZSP = Val(TextBox5.Text)
                gi0Z = Val(TextBox6.Text)
                gi1Z = Val(TextBox7.Text)
                gCTN = Val(TextBox8.Text)
                gCKN = Val(TextBox9.Text)
                gKZ0 = Val(TextBox10.Text)
                gKZP = Val(TextBox11.Text)


                ReDim mZ(gW, gH)
                ReDim gMap(gW, gH)

                ' Loop through the images pixels to reset color.
                txtDataReceived.AppendText("X" + vbTab + "Y" + vbTab + "II" + vbCrLf)
                For x = 0 To image1.Width - 1
                    For y = 0 To image1.Height - 1
                        Dim pixelColor As Color = image1.GetPixel(x, y)
                        gMap(x, image1.Height - 1 - y) = CInt(pixelColor.R) + CInt(pixelColor.G) + CInt(pixelColor.B)

                        txtDataReceived.AppendText(x.ToString + vbTab + y.ToString + vbTab + gMap(x, y).ToString() + vbCrLf)

                        mZ(x, y) = 0

                    Next
                Next

                gi = 0
                gj = 0
                fBX = 1


                gM = 3
                gS = 0
                txtDataReceived.Text = ""
                txtDataReceived.AppendText("i" + vbTab + "j" + vbTab + "gZ0" + vbCrLf)
            End If
            
        Else
            MessageBox.Show("ZT[`sĂII")
        End If

    End Sub

    Sub F3()    'Hs
        Dim str As String
        Dim x, y, z, AD As Integer

        Select Case gS
            Case 0
                If gMap(gi, gj) < 384 Then
                    gS = 20
                Else
                    gS = 10
                End If

            Case 1
                x = (gi - gW / 2) * gPw
                y = (gj - gH / 2) * gPh
                If (fBX) Then
                    z = gZ2 + gi0Z
                Else
                    z = gZ2 + gi1Z
                End If

                SerialPort1.Write("MA#" + x.ToString + "#" + y.ToString + "#" + z.ToString + "#")
                gS = 2
                gText = ""
                gX0 = x : gY0 = y : gZ0 = z
            Case 2
                str = Mid(gText, 1, 2)
                If (str = "MC") Then
                    gS = 3
                End If
            Case 3
                SerialPort1.Write("AD#")
                gS = 4
                gText = ""
            Case 4
                str = Mid(gText, 1, 2)
                If (str = "AD") Then
                    'txtDataReceived.AppendText("Z0" + vbTab + gZ0.ToString + vbCrLf)
                    str = Mid(gText, 4, gText.Length - 5)
                    AD = Val(str)

                    If (AD > VthAD) Then
                        SerialPort1.Write("MR#0#0#" + gZSP.ToString + "#")
                        gText = ""
                        gZ0 = gZ0 + gZSP
                        gS = 5
                    Else
                        gS = 6
                    End If
                End If

            Case 5
                str = Mid(gText, 1, 2)
                If (str = "MC") Then
                    gS = 3
                End If

            Case 6
                If (gS = 6) Then
                    mZ(gi, gj) = gZ0 'ZT[`
                    txtDataReceived.AppendText(gi.ToString + vbTab + gj.ToString + vbTab + gZ0.ToString + vbCrLf)
                    SerialPort1.Write("MR#0#0#" + gKZ0.ToString + "#")
                    gText = ""
                    gZ0 = gZ0 - gKZ0
                    gS = 7


                    
                End If
            Case 7
                str = Mid(gText, 1, 2)
                If (str = "MC") Then
                    SerialPort1.Write("DC#1#")
                    gText = ""
                    gCT = 0 '^CJE^
                    gCK = 0 '񐔃JE^
                    gS = 8
                End If





            Case 8

                If gCT > gCTN Then
                    SerialPort1.Write("MR#0#0#" + gKZP.ToString + "#")
                    gText = ""
                    gZ0 = gZ0 + gKZP
                    gCT = 0
                    If gCK < gCKN Then
                        SerialPort1.Write("DC#0#")
                        gCK = gCK + 1
                        gS = 9
                    Else
                        SerialPort1.Write("DC#0#")
                        gS = 10
                    End If

                Else
                    gCT = gCT + 1
                End If
            Case 9
                If gCT > gCTN Then
                    SerialPort1.Write("DC#1#")
                    gCT = 0
                    gS = 8
                Else
                    gCT = gCT + 1
                End If

            Case 10
                If (gS = 10) Then
                    If (gi < gW - 1) Then

                        gi = gi + 1
                        gS = 0
                        'txtDataReceived.Text = ""
                    Else
                        If (gj < gH - 1) Then
                            fBX = 1
                            gi = 0
                            gj = gj + 1
                            gS = 0
                            'txtDataReceived.Text = ""
                        Else
                            gS = 11
                        End If
                    End If
                End If
                
            Case 11

            Case 20
                If (fBX = 1) Then
                    SerialPort1.Write("MR#0#0#" + gi0Z.ToString + "#")
                    gText = ""
                    gZ0 = gZ0 + gi0Z
                    gS = 21
                    'fBX = 0
                Else
                    SerialPort1.Write("MR#0#0#" + gi1Z.ToString + "#")
                    gText = ""
                    gZ0 = gZ0 + gi1Z
                    gS = 21
                End If
            Case 21
                str = Mid(gText, 1, 2)
                If (str = "MC") Then
                    gS = 22
                End If

            Case 22
                If (fBX = 1) Then
                    x = (gi - gW / 2) * gPw - 500
                    y = (gj - gH / 2) * gPh - 500
                    z = gZ2 + gi0Z
                    SerialPort1.Write("MA#" + x.ToString + "#" + y.ToString + "#" + z.ToString + "#")
                    gS = 23
                    gText = ""
                    gX0 = x : gY0 = y : gZ0 = z
                    fBX = 0
                Else
                    gS = 1
                End If

            Case 23
                str = Mid(gText, 1, 2)
                If (str = "MC") Then
                    gS = 1
                End If




            Case Else

        End Select

    End Sub


    Private Sub Button5_Click(sender As System.Object, e As System.EventArgs) Handles Button5.Click
        SerialPort1.Write("MA#0#0#0#")
    End Sub
End Class
